# Cisco iSocket MQTT Java DSLink

## Last Update: 
2017-09-20

## Author and Maintainer: 
Yinxin Xia <yixia@cisco.com>

## Description
The Java Responder DSLink to support communication with MQTT broker of iSocket Gateway.

## Build Deployment Package
This section will introduce how to compile source code and build the deployment package.

### Preparation
1.  Setup the CentOS 6/7 or Ubuntu 14/16 node for development; 

2.  Install the Java JDK, Maven and Gradle

	* Ubuntu 14/16: 
```sh
		$ sudo apt-get update
		$ sudo apt-get install openjdk-8-jdk maven gradle
```
	* CentOS
	
		CentOS 6 or 7 doesn't have gradle in repository by default. 

		Please follow the official guide to install: https://docs.gradle.org/current/userguide/installation.html
```sh
		$ sudo yum update
		$ sudo yum install java-1.8.0-openjdk maven
```
	* Mac OSX

		OpenJDK or Oracle-JDK: download the package from the official web site to install 
		
		Gradle:
```sh
		$ brew install maven gradle
```

### Build the Package
1.  Sync up the source code from GIT
```sh
	$ git clone ssh://git@gitlab.ipg.guru:6622/dsa/cisco-dslink-isocket.git
```		

	Or pull the latest code from the master if already cloned
```sh
	$ cd cisco-dslink-isocket
	$ git pull origin master 
```

2.  Build the project by gradle
```sh
	$ cd cisco-dslink-isocket
	$ rm -fr build
	$ gradle build
```

3.  Get the ZIP package if built sucessfully
```sh
	$ ls ./build/distributions/cisco-dslink-isocket-$version.zip
```

## Deploy package in EFF or DGLux5

### Install EFF or DGLux5

1.  EFF: 

    Please download the package and guide of EFF to install.
    
2.  DGLux5

    Please download the package from: http://iot-dsa.org/get-started/download-dsa, and follow up the guide of it.

### Deploy DSLink ZIP package to EFF/DGLux5

1.  Install and Start DSLink
	
	1)  Open Web GUI of EFF/DGLux5 with browser and login;

	2)  Go to "data panel" -> "sys" -> "links", and right click;

	3)  Choose "install links" -> "from ZIP";

	4)  Choose the DSLink package from your machine, and input the name: cisco-dslink-isocket, then click "invoke" to install;

	5)  If installed successfully, it will show "Success!" in the installation widght;

	6） Right click "links" again, and click "Rescan", then if anything is OK, the "cisco-dslink-isocket" will appear under "links";

	7） Right click the "cisco-dslink-isocket", and click "Start Link", then check whether the status turns to "connected";
	
	8） Go to "data panel" -> "downstream" to check whether the "cisco-dslink-isocket" node setup;

2.  Add a new Connection in DSLink 

    1） Right click "downstream->cisco-dslink-isocket", and choose "create";
    
    2） Input the value of configuration, and click "invoke":

        * "name": the name of the connection;
        
        * "mqttBroker": the MQTT broker URL, the default is: tcp://localhost:1883;
        
        * "mqttUsername": the username of MQTT broker;
        
        * "mqttPassword": the password of MQTT broker;
        
        * "mqttTopic": the topic of MQTT broker to subscribe, the default is "isockets/Device/#";
        
        * "mqttClientId": the client id of MQTT subscriber;
        
        * "mqttQoS": the QoS of MQTT subscriber;
        
        * "threadNum": the thread number of data processing;
        
        * "dataNodeName": the data node name, the default is "data";
        
        * "controlNodeName": the control invoker node name, the default is "control";

3.  Delete a Connection

    1） Right click "downstream->cisco-dslink-isocket", and choose "delete";
    
    2） Input the name of connection, and click "invoke":
    
    or
    
    1) Right click "downstream->cisco-dslink-isocket->$name", and choose "delete";
    
    2) click the "invoke";

4.  Check the log
	
	1)  Login EFF/DGLux5 Linux node with SSH;

	2)  Go to the EFF/DGLux5 folder with "cd" command;

	3)  Open DSLink log with "vi" command or tract it with "tailf": "dslinks/cisco-dslink-isocket.log";
	
	4)  Check whether there is any error log if DSLink failed to install, setup or create connection;

### Update/Re-deploy DSLink ZIP package to EFF/DGLux5

1.  Build to get the new version of the ZIP package of DSLink;

2.  Update the DSLink in EFF/DGLux5
	
	1)  Open Web GUI of EFF/DGLux5 with browser and login;

	2)  Go to "data panel" -> "sys" -> "links" -> "cisco-dslink-isocket", and right click;

	3)  Choose "Update" -> "from ZIP";

	4)  Choose the DSLink package from your machine, and then click "invoke" to install;

	5)  If installed successfully, it will show "Success!" in the update widght;

	6） Right click "cisco-dslink-isocket" again, and click "Restart Link" to restart it, then check the status;

3.  Check whether old connections are restored

    1)  Go to "data panel" -> "downstream" -> "cisco-dslink-isocket", and click it;
    
    2)  Check whether the old connection nodes which were created before updating are restored and still existed;
    
    3)  Verify the data flow and check whether there is output data;

4.  Check the log if there is any issue

	